<?php


namespace Drupal\eav_field\Entity;

use Drupal\Core\Entity\ContentEntityInterface;
use Drupal\Core\Field\FieldItemListInterface;

interface EavValueInterface extends ContentEntityInterface {

  /**
   * Return supported value field types.
   */
  public static function getFieldTypes(): array;

  /**
   * Return attribute id.
   */
  public function getAttributeId(): ?int;

  /**
   * Return attribute entity.
   */
  public function getAttributeEntity(): ?EavAttributeInterface;

  /**
   * Return value field name.
   */
  public function getValueFieldName(): ?string;

  /**
   * Return value field items.
   */
  public function getValueFieldItems(): ?FieldItemListInterface;

  /**
   * Return values field value.
   */
  public function getValueFieldValue(): ?array;

  /**
   * Format value field in selected formatter.
   *
   * @return array|string
   */
  public function viewValueField();

}
